// u[ʊ{
#include "DxLib.h"

#define SCREEN_W		640				// ʂ̉
#define SCREEN_H		480				// ʂ̏c
#define DOWN_SCALE		8				// KEXtB^|摜ʂ̃TCỶ̂P
#define DOWN_SCALE_SCREEN_W	( SCREEN_W / DOWN_SCALE )	// KEXtB^|摜̉
#define DOWN_SCALE_SCREEN_H	( SCREEN_H / DOWN_SCALE )	// KEXtB^|摜̏c

int ColorScreen ;	// ʂ̕`挋ʂރXN[
int HighBrightScreen ;	// ʂ̕`挋ʂ獂Px𔲂oʂރXN[
int DownScaleScreen ;	// PxkʂރXN[
int GaussScreen ;	// k摜KEXtB^łڂʂރXN[

// WinMain֐
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int Angle ;		// J̐px
	int StageModel ;	// Xe[Wf
	int GaussRatio ;	// KEXtB^̂ڂx

	// EChE[hŋN
	ChangeWindowMode( TRUE );

	// ʂ̉𑜓xƐFrbg[xݒ
	SetGraphMode( SCREEN_W, SCREEN_H, 32 ) ;

	// cwCȕ
	if( DxLib_Init() < 0 )
		return -1 ;

	// Xe[Wf̓ǂݍ
	StageModel = MV1LoadModel( "BloomTestStage.mqo" ) ;

	// ʏ̕`挋ʂރXN[ƁAtB^[̏ʂރXN[̍쐬
	ColorScreen      = MakeScreen( SCREEN_W, SCREEN_H, FALSE ) ;
	HighBrightScreen = MakeScreen( SCREEN_W, SCREEN_H, FALSE ) ;
	DownScaleScreen  = MakeScreen( DOWN_SCALE_SCREEN_W, DOWN_SCALE_SCREEN_H, FALSE ) ;
	GaussScreen      = MakeScreen( DOWN_SCALE_SCREEN_W, DOWN_SCALE_SCREEN_H, FALSE ) ;

	// ClearDrawScreen ɉʂɓhԂFZbg( ^ )
	SetBackgroundColor( 255, 255, 255 ) ; 

	// J̊pxƃKEXtB^̂ڂx
	Angle = 0 ;
	GaussRatio = 900 ;

	// C[v(L[ꂽ烋[v𔲂)
	while( ProcessMessage() == 0 )
	{
		// EL[ꂽJ]
		if( CheckHitKey( KEY_INPUT_LEFT  ) )
		{
			Angle -= 3 ;
			if( Angle < 0 )
			{
				Angle += 360 ;
			}
		}
		if( CheckHitKey( KEY_INPUT_RIGHT ) )
		{
			Angle += 3 ;
			if( Angle > 360 )
			{
				Angle -= 360 ;
			}
		}

		// ㉺L[ꂽKEXtB^̂ڂxύX
		if( CheckHitKey( KEY_INPUT_UP ) )
		{
			GaussRatio ++ ;
		}
		if( CheckHitKey( KEY_INPUT_DOWN ) )
		{
			if( GaussRatio > 0 )
				GaussRatio -- ;
		}


		// ʏ̕`挋ʂރXN[`Ώۂɂ
		SetDrawScreen( ColorScreen ) ;

		// ʂNA
		ClearDrawScreen() ;


		// J̈ʒuƌݒ
		SetCameraPositionAndAngle( VGet( 0.0f, 120.0f, 0.0f ), 0.0f, Angle / 180.0f * 3.14159f, 0.0f ) ;

		// Xe[Wf̕`
		MV1DrawModel( StageModel ) ;


		// `挋ʂ獂Px݂̂𔲂o摜𓾂
		GraphFilterBlt( ColorScreen,      HighBrightScreen, DX_GRAPH_FILTER_BRIGHT_CLIP, DX_CMP_LESS, 230, TRUE, GetColor( 0, 0, 0 ), 255 ) ;

		// PxŴPɏk摜𓾂
		GraphFilterBlt( HighBrightScreen, DownScaleScreen,  DX_GRAPH_FILTER_DOWN_SCALE, DOWN_SCALE ) ;

		// ŴPɏk摜KEXtB^łڂ
		GraphFilterBlt( DownScaleScreen,  GaussScreen,      DX_GRAPH_FILTER_GAUSS, 16, GaussRatio ) ;


		// `Ώۂ𗠉ʂɂ
		SetDrawScreen( DX_SCREEN_BACK ) ;


		// ʏ̕`挋ʂ`悷
		DrawGraph( 0, 0, ColorScreen, FALSE ) ;


		// `惂[hoCjAtB^Oɂ( g債ƂɃhbgڂ₯悤ɂ )
		SetDrawMode( DX_DRAWMODE_BILINEAR ) ;

		// `uh[hZɂ
		SetDrawBlendMode( DX_BLENDMODE_ADD, 255 ) ;

		// PxkĂڂ摜ʂςɂQ`悷( Q`悷̂͂薾邭݂悤ɂ邽 )
		DrawExtendGraph( 0, 0, SCREEN_W, SCREEN_H, GaussScreen, FALSE ) ;
		DrawExtendGraph( 0, 0, SCREEN_W, SCREEN_H, GaussScreen, FALSE ) ;

		// `uh[huhɖ߂
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 ) ;

		// `惂[hAXgɖ߂
		SetDrawMode( DX_DRAWMODE_NEAREST ) ;


		// tB^[̓ro߂悤ɉʉɏkĕ`悷
		DrawExtendGraph( 180 * 0 + 24, 320, 180 * 0 + 24 + 160, 120 + 320, HighBrightScreen, FALSE ) ;
		DrawExtendGraph( 180 * 1 + 24, 320, 180 * 1 + 24 + 160, 120 + 320, DownScaleScreen, FALSE ) ;
		DrawExtendGraph( 180 * 2 + 24, 320, 180 * 2 + 24 + 160, 120 + 320, GaussScreen, FALSE ) ;


		// ݂̃KEXtB^̂ڂx`悷
		DrawFormatString( 0, 0, GetColor( 255,255,255 ), "Gauss:%d", GaussRatio ) ;


		// ʂ̓e\ʂɔf
		ScreenFlip();
	}

	// cwCǔn
	DxLib_End();

	// \tg̏I
	return 0;
}
